searchNodes=[{"ref":"Microscope.html","title":"Microscope","module":"Microscope","type":"module","doc":"Microscope is a simple static web server built using cowboy. It&#39;s original purpose was to provide an easy way to test your static websites, but it&#39;s also useful as a temporary server for file sharing over HTTP. Getting started Use Microscope.start_link/2 to start the web server. # Example: {:ok, pid} = Microscope.start_link(&quot;/home/user/www&quot;, [base: &quot;/base&quot;, port: 8080]) Then the HTTP server will start listening on port 8080, and when the user requests /base/path/to/file, the server will respond with the contents of /home/user/www/path/to/file on your system."},{"ref":"Microscope.html#start_link/2","title":"Microscope.start_link/2","module":"Microscope","type":"function","doc":"Starts Microscope simple static web server. By default, the server will start listening on port 8080, and serve files located under the webroot directory. This behavior can be customized by using the options below. Options The second argument of this function expects a keyword list containing zero or more options listed below: port: A port the web server listens on. The default value is 8080. base: A string that represents the base URL. Any URL with the form of &lt;base&gt;/path/to/file will be mapped to &lt;webroot&gt;/path/to/file; any other requests will result in 404 error. The default value is &quot;/&quot;. index: See below. callbacks: See below. The &quot;index&quot; Option When a user requests a directory, Microscope looks for either index.html or index.htm under that directory, and serves the file if found. If neither of them exists, how the server responds is determined by this option. If index is set to true, Microscope will generate an HTML page containing a list of subdirectories and files and respond with 200 OK. If index is set to false, the user will receive a 404 error. The default value for this option is false. The &quot;callbacks&quot; Option The callbacks option expects a list of modules, each module implementing Microscope.Callback behaviour. For example, if you want a line of access log printed on every requests, use the built-in Microscope.Logger module. The default value is an empty list. Return Value This function returns {:ok, pid} on success, where pid is a PID of process which can be later be stopped using Microscope.stop/1,2 function. If this function fails for some reason, one of the followings will happen: If the calling process does not trap exits, the process will exit with reason, where reason is any Elixir term describing the error information. Otherwise, this function will return {:error, reason} and the calling process will receive {:EXIT, pid, reason} message."},{"ref":"Microscope.html#stop/2","title":"Microscope.stop/2","module":"Microscope","type":"function","doc":"Stops the server specified by pid."},{"ref":"Microscope.html#t:options/0","title":"Microscope.options/0","module":"Microscope","type":"type","doc":"A keyword list containing options for Microscope"},{"ref":"Microscope.html#t:route_path/0","title":"Microscope.route_path/0","module":"Microscope","type":"type","doc":""},{"ref":"Microscope.Callback.html","title":"Microscope.Callback","module":"Microscope.Callback","type":"behaviour","doc":"A behaviour module for implementing callback modules for Microscope static web server."},{"ref":"Microscope.Callback.html#c:on_200/3","title":"Microscope.Callback.on_200/3","module":"Microscope.Callback","type":"callback","doc":"Called when the server replied with HTTP 200 (OK)."},{"ref":"Microscope.Callback.html#c:on_404/3","title":"Microscope.Callback.on_404/3","module":"Microscope.Callback","type":"callback","doc":"Called when the server replied with HTTP 404 (Not Found)."},{"ref":"Microscope.Callback.html#c:on_request/0","title":"Microscope.Callback.on_request/0","module":"Microscope.Callback","type":"callback","doc":"Called when the server received a request, and before the server sends a response."},{"ref":"Microscope.Logger.html","title":"Microscope.Logger","module":"Microscope.Logger","type":"module","doc":"A callback module that logs HTTP requests to the stdout."},{"ref":"Microscope.Logger.html#on_200/3","title":"Microscope.Logger.on_200/3","module":"Microscope.Logger","type":"function","doc":"Called when the server replied with HTTP 200 (OK). Callback implementation for Microscope.Callback.on_200/3."},{"ref":"Microscope.Logger.html#on_404/3","title":"Microscope.Logger.on_404/3","module":"Microscope.Logger","type":"function","doc":"Called when the server replied with HTTP 404 (Not Found). Callback implementation for Microscope.Callback.on_404/3."},{"ref":"Microscope.Logger.html#on_request/0","title":"Microscope.Logger.on_request/0","module":"Microscope.Logger","type":"function","doc":"Called when the server received a request, and before the server sends a response. Callback implementation for Microscope.Callback.on_request/0."},{"ref":"Mix.Tasks.Microscope.html","title":"Mix.Tasks.Microscope","module":"Mix.Tasks.Microscope","type":"task","doc":"A Mix task that provides an express way to launch a static web server."},{"ref":"Mix.Tasks.Microscope.html#run/1","title":"Mix.Tasks.Microscope.run/1","module":"Mix.Tasks.Microscope","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."}]